﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.3
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
#End Region

'Activity module
Sub Process_Globals
	Dim AStream As AsyncStreams
	'the main buttons are represented by count-downs so the button
	'state is sent multiple times in response to status requests
	Dim ScanPressed As Int
	Dim LeftPressed As Int
	Dim RightPressed As Int
	Dim EnterPressed As Int
	Dim rxBuffer As StringBuilder
	'Dim rxBytes(300) As Byte		' byte array for rx
	'Dim rxPtr As Int = 0			' index to rxBytes
	Dim rxAuxCSum As Int = 0
	Dim SM_Debug As Boolean = False
	' global declaration and var for WFT downloading in ChatActivity (apparently this is where to declare it)
	Type FileVars(FCnt_Sys As Int, FChk_Sys As Int, FCur_Type As Char, FCnt_Pwr As Int, FChk_Pwr As Int, Blocks As Int, Length As Int, FLast_Rolling As Char, FName As String)
	Public Filing As FileVars
	Type TCommsGen(pBB As Int, wTemp As Int, bTemp As Byte, bCnt As Int)
	Public CommsGen As TCommsGen
	' track the graphics cursor
	
	Type TLCDGraphics(X As Int, Y As Int, GMode As Boolean, FirstLine As Boolean, PendingData As Boolean, Biggest As Int, Smallest As Int, HalfScale As Float)
	Public LCDGraphics As TLCDGraphics
	Dim SendExpertCount As Int
	
	Type THighlighting(Start As Int, Last As Int)
	Public Highlighting As THighlighting
	
	' create strings with CR and LF for using with m and j (escaped char) replacement
	Dim MtoCR As StringBuilder
	MtoCR.Initialize
	MtoCR.Append(Chr(13))
	Dim JtoLF As StringBuilder
	JtoLF.Initialize
	JtoLF.Append(Chr(10))
	Dim findFF As StringBuilder
	findFF.Initialize
	findFF.Append(Chr(127))
	Dim myCRLF As StringBuilder
	myCRLF.Initialize
	myCRLF.Append(Chr(13))
	myCRLF.Append(Chr(10))
	
	
End Sub

Sub Globals
	Private btnLeft As Button
	Private btnEnter As Button
	Private btnRight As Button
	Private btnScan As Button
	Private lblLine1 As Label
	Private lblLine2 As Label
	Private lblLine3 As Label
	Private lblLine4 As Label
	Private lblLine5 As Label
	Private lblLine6 As Label
	Private lblLine7 As Label
	Private lblLine8 As Label
	' Panel3 is used to provide a coloured background to the edit controls used to mimic
	' the 8 line display in text mode, and to draw the graphics on, in which case it is 
	' brought to the front of lines 1 to 8 then Line 8 is brought back to the front.  
	Private Panel3 As Panel
	Private cvsGraph As Canvas
	
	Private myFileName As String
	Private myStarString As StringBuilder
	Private GraphicData(128) As Float

End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("2")
	If AStream.IsInitialized = False Then
		' SM do not use prefix mode. 
		' AStream.InitializePrefix(Main.serial1.InputStream, True, Main.serial1.OutputStream, "AStream")
		AStream.Initialize(Main.Serial1.InputStream, Main.Serial1.OutputStream, "AStreams")
	End If
	If rxBuffer.IsInitialized = False Then
		rxBuffer.Initialize
	End If
	If Main.Expertmode Then SendExpertCount = 3 Else SendExpertCount = 0

	' init the graphic for the panel
	cvsGraph.Initialize(Panel3)
	ClearHighlighting
	
	' Create a log file name
	DateTime.DateFormat = "yyyy-MM-dd"
	DateTime.TimeFormat = "HH-mm-ss"
	myFileName = "L" & Common.CurrentAlias & "-" & DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & ".txt"
	Dim S As String
	' try to create a dir entry for log file name. If a problem with SD card show error
	' message and reset file name to flag subsequent attempts to use it for logging. 
	s = CreateDirEntry(myFileName)
	If s <> "OK" Then
		myFileName = ""
		ToastMessageShow(S, True)
	End If
	
	' make a seperator string for logs
	myStarString.Initialize
	Dim i As Int
	For i = 1 To 21
		myStarString.Append("*")
	Next
	
	Common.KeepScreenOn(True)
	' try to stop the colour/graphics panel getting resized incorrectly	on large phones
	Panel3.Height = lblLine1.Height * 8
	
End Sub

Sub SMLog(S As String)
	If SM_Debug = True Then Log(S)
End Sub

'SM This method was admitted to being misspelled AStream_NewData by the author 
	' first scan the buffer and remove the top bit from any chars while
	' also bookmarking their position and adding them to a checksum
	' due to the stupid Java representation of Byte as SIGNED, anything > 127
	' appears negative!!!
	' embedded CRs and LFs qualify here because they have 0xE0 added to them (so-called Escape)
	' to prevent them being mixed up with the actual packet terminator CRLF. 
	' so actually we only care about 0xFF (EOF), 0xEA (LF) and 0xED (CR) 
	' Graphic data is not escaped just bloated by 0x40 but not > 0x7F.
	' Mark the start and end locations of highlighting.

Sub AStreams_NewData (Buffer() As Byte)
	SMLog("You" & BytesToString(Buffer, 0, Buffer.Length, "UTF8")) ' was UTF8
	Dim N As Int
	For N = 0 To Buffer.Length - 1 
		If Buffer(N) < 0 Then
			SMLog("Top Bit Found Pos " & N)
			rxAuxCSum = rxAuxCSum + 128
			' this code currently converts CR/LF to 0x6D 0x6A as an interrim measure
			' because converting to actual CR/LF interferes with the packet logic
			' to the file data packet process needs to convert them...
			Buffer(N) = Buffer(N) + 128
			If Highlighting.Start = -1 Then
				Highlighting.Start = N + rxBuffer.Length
				Highlighting.Last = N + rxBuffer.Length
			Else
				Highlighting.Last = N + rxBuffer.Length
			End If
		End If
	Next
	
	'save the received data
	rxBuffer.Append(BytesToString(Buffer, 0, Buffer.Length, "UTF8")) ' was UTF8
	Dim myInt As Int
	' NOTE this is probably not working quite as designed because CRLF is only LF (no CR)
	' but this is benign so long as we leave it alone... 
	myInt = rxBuffer.ToString.IndexOf(CRLF)
	SMLog("Incoming len " & rxBuffer.ToString.Length & " CRLF at " & myInt)
	If (myInt > -1) Then
		'process the data
		Dim s As String
		s = rxBuffer.ToString
		s = s.SubString2(0, myInt - 1) 'omit the CRLF
		SMLog("Removed CRLF new length " & s.Length)
		SMLog("Processing Packet: " & s)
		ProcessPacket(s)
		'remove the data we don't need and clear the aux checksum
		rxBuffer.Remove(0, myInt + 1)
		rxAuxCSum = 0
		ClearHighlighting
	End If
	' else leave the rxBuffer as is
End Sub

' Handler for broken stream
'11-04-2019 Surely should be AStreams_xxx not AStream_xxx???
'see https://www.b4x.com/android/forum/threads/b4x-asyncstreams-tutorial.7669/
' 12-04-2019 NEW - call to Activity.Finish causes Activity_Pause() then close of activity
Sub AStreams_Error
	ToastMessageShow("Connection is broken.", True)
	Activity.Finish 
End Sub

' Handler for broken stream
'11-04-2019 Surely should be AStreams_xxx not AStream_xxx???
Sub AStreams_Terminated
	AStreams_Error
End Sub

Sub Activity_Resume
	ClearDisplay
	
	If Common.MyMap.Get("AutoCap") Then 
		Common.ScreenShot(Activity.Width, Activity.Height, "Connect")
	End If

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		AStream.Close
	End If
End Sub


Sub BtnEnter_Click
	EnterPressed = 3
End Sub

Sub btnLeft_Click
	LeftPressed = 3
End Sub

Sub btnRight_Click
	RightPressed = 3
End Sub

Sub btnScan_Click
	ScanPressed = 3
End Sub


'Process incoming command, (no crlf) according to the HH / WFT-2 protocol
' Extra notes about file rx from WFT unit...
' The receive data length cannot be > 127 bytes because of limitations of the
' PSOC receive buffer driver so the protocol limits packets to less.
' The PSOC Loop converts any escaped chars back to CR, LF and updates the contents of Buffer.
' Any chars < 0x20 are escaped by adding 0xE0. 
' This is done because these chars would otherwise trigger the PSOC driver's
' end of packet logic. This is complicated by the shitty Java Byte representation
' because the escaping is done by adding 0xE0 to CR and LF, and our checksum
' routine works around Byte being -127 to +128 by conditionally adding 128
' so this will have already converted CR and LF but results in EOF (0xFF) being 127.

Sub ProcessPacket(Buffer As String)
	Dim Command, Payload, n As Int
	Dim AlreadySent As Boolean = False
	Dim CSum As String
	
	SMLog("ProcessPacket passed " & Buffer)
	'The packet must start with "="
	If Buffer.StartsWith("=") Then
		'the crlf has not been passed in with Buffer
		Dim CommaCnt As Int
		Dim lastndx As Int
		lastndx = 0
		CommaCnt = 0
		For n = 0 To Buffer.Length - 1
			If Buffer.SubString2(n, n+1) = "," Then
				lastndx = n
				CommaCnt = CommaCnt + 1
			End If
		Next
		SMLog("Found " & CommaCnt & " Commas, Last at " & lastndx & " len " & Buffer.Length)

		' check last comma is in the right place for the checksum
		If lastndx = Buffer.Length - 3 Then
			
			SMLog("Last comma in the right place")
			
			CSum = CheckSum(Buffer.SubString2(0, lastndx), False)
			If CSum <> Buffer.SubString2(lastndx + 1, lastndx + 3) Then
				SMLog("Incorrect CSum, rx " & Buffer.SubString2(lastndx + 1, lastndx + 3) & " calced " & CSum)
				
			Else
	
				Command = Bit.ParseInt(Buffer.SubString2(2,4), 16)
				' Payload = GetWORDFromCommand() (even if it's a display)
				'e.g. 0123456789ABCDEF
				'e.g. =A01,0000,HH
				'except when using filing commands
				
				
				Select Command
					Case 128 'NetCmdControl: 0x80
						Payload = Bit.ParseInt(Buffer.SubString2(5,9), 16)
						SMLog("Command " & Command & " Payload " & Payload)
						If Payload = 0 Then
							'power down, so disconnect
							
						Else
							If Payload = 2 Then ' WFT sends us this with payload 3 initially
								ClearDisplay 
							End If
							'no handler needed For Case 3 (report status)
							'because this happens below
						End If
					'Case 129 'NetCmdBacklight: 0x81
					Case 130 'NetCmdDisplay: 0x82
						Payload = Bit.ParseInt(Buffer.SubString2(5,9), 16)
						SMLog("Command " & Command & " Payload " & Payload)
						LocalNetDisplay(Buffer, Payload)
					Case 131 'NetCmdStatus: 0x83
						'if we receive this message ignore the payload and reply normally
					'Case 132 'NetCmdLarge: 0x84
					Case 133 'NetCmdClearScreen: 0x85
						' this usually controls the backlight too
						Payload = Bit.ParseInt(Buffer.SubString2(5,9), 16)
						SMLog("Command " & Command & " Payload " & Payload)
						ClearDisplay
					Case 135 'NetCmdGraphics: 0x87
						'PlotGraphics	
						' The WFT sends a Clear Screen command first, then two packets of graphics. 
						' These have a normal header and a payload that is 64 x Y data. The X data
						' is reset by Clear Screen. The Y data is the bit to plot vertically 0..0x3F
						' and has 0x40 already added to avoid clashing with CR,LF etc. So to plot
						' we just need to subtract 0x40 as all will be in the printable range 0x40..0x7F
						' then starting from the last plotted point draw a line to the next virtual
						' screen position. Therefore we need to reset X and Y and update them as we go.
						' Line 8 is sent some standard text to display. 
						DrawGraphics(Buffer.SubString(5))
						
					'Case 142 'NetCmdBacklightDim 0x8E
						' not implemented for Lubrizol
					Case 136 'NetCmdFileName: 0x88
						' initialise everything for a download
						' HH drops connection here if it cannot write to flash for whatever reason
						Display_Downloading
						' remove the final comma and checksum
						Buffer = Buffer.SubString2(0, Buffer.Length - 3)
						' replace space and : in the name with -
						Buffer = Buffer.Replace(":", "-")
						Buffer = Buffer.Replace(" ", "-")
						' show the file name
						lblLine5.Text = Buffer.SubString(5)
						' create file with the same name
						Filing.FName = Buffer.SubString2(5, 6) & Common.CurrentAlias & "-" & Buffer.SubString(6) & ".txt"
						'Filing.FName = Buffer.SubString(5) & ".txt"
						'Filing.FName.Replace("P", "P" & )
						'Filing.FName.Replace("S", "S" & Common.CurrentAlias & "-")
						lblLine6.Text = CreateDirEntry(Filing.FName)
						
						If Buffer.SubString2(5, 6) = "S" Then
							' system log file
							Filing.FCnt_Sys = 0
							Filing.FChk_Sys = 0
							Filing.FCur_Type = "S"
							Filing.FCnt_Pwr = 0
							Filing.FChk_Pwr = 0
							Filing.Blocks = 0
							Filing.Length = 0
						Else
							' power log file 
							Filing.FCur_Type = "P"
							Filing.FCnt_Pwr = 0
							Filing.FChk_Pwr = 0
							Filing.Blocks = 0
							Filing.Length = 0							
						End If
						Filing.FLast_Rolling = " "
						
												
					Case 137 'NetCmdFileData: 0x89
					
						' save a file packet
						
						' display the packet number, the first payload byte
						Filing.Blocks = Filing.Blocks + 1
						' remove the final comma and checksum
						Buffer = Buffer.SubString2(0, Buffer.Length - 3)
						' display the block number
						lblLine7.Text = "B=" & Filing.Blocks
						' display the transmitted string length (not including the rolling char)
						CommsGen.bTemp = Buffer.SubString(6).Length
						Filing.Length = Filing.Length + CommsGen.bTemp
						lblLine8.Text = "L=" & Filing.Length
						
						' this is where the HH scan's the data for escapes, etc (see notes above)
						' the NewData fn has set CR and LF to 0x6D, 0x6A (m, j) temporarily

						Buffer = Buffer.Replace("m", MtoCR.ToString)
						Buffer = Buffer.Replace("j", JtoLF.ToString)
												
						CommsGen.bTemp = Buffer.Length - 5
						' check if the packet is not a repeat. The char at (5) changes 0..9
						If Filing.FLast_Rolling <> Buffer.CharAt(5) Then
							Filing.FLast_Rolling = Buffer.CharAt(5)
							
							' is there an FF (converted to 127)? If so note it.
							Dim FFPos As Int
							FFPos = Buffer.IndexOf(findFF.ToString)
							' Delete the rest of the string
							If FFPos > 5 Then
								Buffer = Buffer.SubString2(0, FFPos)
							End If

							' add to byte count and checksum for information only
							If Filing.FCur_Type = "S" Then
								Filing.FCnt_Sys = Filing.FCnt_Sys + 1
								Filing.FChk_Sys = Filing.Length
							Else
								Filing.FCnt_Pwr = Filing.FCnt_Pwr + 1
								Filing.FChk_Pwr = Filing.Length
							End If
							
							If FFPos > 5 Then
								' display stats If it's Power (2nd file)
								If Filing.FCur_Type = "P" Then
									lblLine7.Text = "S=" & Filing.FCnt_Sys & " " & Filing.FChk_Sys
									lblLine8.Text = "P=" & Filing.FCnt_Pwr & " " & Filing.FChk_Pwr
								End If
							End If
							
							' save to flash
							AppendToFile(Filing.FName, Buffer.SubString(6))

						End If
					Case 138 'case NetCmdFileReset:
						' reset the file pointer etc for the polling program						
					Case 139 'case NetCmdFileErase:
						' erase ALL files after going off line
						' this is used by the polling program and not a WFT unit
					Case 140 'NetCmdFileReadNext
						' used by polling program
					Case 141 'NetCmdFileStats
						' used by polling program
				End Select
				
				' 11-04-2019 Noted while reading through code: AlreadySent is always false.
				If AlreadySent = False Then
					If SendExpertCount > 0 Then
						' send left and enter keys pressed three times when logging on
						SendHeader(131, 34 + 256)
						SendExpertCount = SendExpertCount - 1
					Else
						SendHeader(131, KeyMap + 256)
					End If
					
				End If
				DecKeys
			
				
			End If ' checksum is okay
			
		End If ' last comma is in the right place
		
	End If ' starts with "="
	
End Sub


Sub SendHeader(Command As Int, Payload As Int)
	Dim txBuffer As StringBuilder
	Dim Temp As String

	txBuffer.Initialize
	txBuffer.Append(">9")
	txBuffer.Append(IntToHexString2(Command))
	txBuffer.Append(",")
	txBuffer.Append(IntToHexString4(Payload))
	Temp = CheckSum(txBuffer.ToString, True)
	' the final comma etc is not included in the checksum calculation
	txBuffer.Append(",")
	txBuffer.Append(Temp)
	'txBuffer.Append(CRLF)
	txBuffer.Append(Chr(13))
	txBuffer.Append(Chr(10))
	

	SMLog("SendHeader: " & txBuffer.ToString)
	
	AStream.Write(txBuffer.ToString.GetBytes("UTF8")) ' was UTF8
	' SMLog("Me:" & txBuffer.ToString)
End Sub

' Trying to make it work even if some chars have bit 7 set,
' not forgetting that a Java Byte treats > 127 as NEGATIVE!
' thus the Rx function removes bit 7 and adds then to rxAuxCSum.
Sub CheckSum(MyBuffer As String, TxMode As Boolean) As String
	Dim n, acc, temp As Int
	If TxMode = False Then
		acc = rxAuxCSum ' for Rx Mode, use total value of bit 7's
	Else
		acc = 0	' for Tx mode, ignore any Rx value and do the bit 7 calc from 0
	End If
	For n = 0 To MyBuffer.Length - 1
		temp =  Asc(MyBuffer.CharAt(n))
		acc = acc + temp
	Next
	' dispose of overflow
	If (acc > 255) Then
		temp = acc / 256
		acc = acc - (256 * temp)
	End If
	
	Return IntToHexString2(acc)
	'Return IntToHexString2(0) 
	' in fact HH will tolerate zero checksum but WFT won't for development
	' and WFT will tolerate the last of the last comma and checksum
	' but this was just to do the original R&D! 
	
End Sub

' convert int up to 65535 to hex string with 4 digits
Sub IntToHexString4(myInt As Int) As String
	Dim HexChars As String = ("0123456789ABCDEF")
	Dim mybuffer As String
	If myInt < 65536 And myInt >= 0 Then
		Dim Divisor, n, temp As Int
		Divisor = 4096
		For n = 1 To 4
			temp = myInt / Divisor
			myInt = myInt - (Divisor * temp)
			Divisor = Divisor / 16
			mybuffer = mybuffer & HexChars.SubString2(temp, temp+1)	
		Next	
	Else
		mybuffer = "XXXX"	
	End If
	
	Return mybuffer
End Sub

' convert int up to 255 to hex string with 2 digits
Sub IntToHexString2(myInt As Int) As String
	Dim HexChars As String = ("0123456789ABCDEF")
	Dim mybuffer As String
	If myInt < 256 And myInt >= 0 Then
		Dim Divisor, n, temp As Int
		Divisor = 16
		For n = 1 To 2
			temp = myInt / Divisor
			myInt = myInt - (Divisor * temp)
			Divisor = Divisor / 16
			mybuffer = mybuffer & HexChars.SubString2(temp, temp+1)	
		Next	
	Else
		mybuffer = "XX"	
	End If
	
	Return mybuffer
End Sub

' Net Display Clear Display in Text Mode
Sub ClearDisplay
	Log("ClearDisplay")
	lblLine1.Text = ""
	lblLine2.Text = ""
	lblLine3.Text = ""
	lblLine4.Text = ""
	lblLine5.Text = ""
	lblLine6.Text = ""
	lblLine7.Text = ""
	lblLine8.Text = ""
	' Generally, WFT sends all 8 lines for text displays but always before a NEW graphics
	LCDGraphics.X = 0
	LCDGraphics.Y = 0
	' scrub the existing bitmap
	If LCDGraphics.GMode = True Then RestoreTextModeDisplay
	ScrubGraphics
End Sub

Sub ScrubGraphics
	LCDGraphics.GMode = False
	LCDGraphics.FirstLine = True
	LCDGraphics.PendingData = False
	LCDGraphics.Biggest = 0
	LCDGraphics.Smallest = 0
	LCDGraphics.HalfScale = 0
End Sub

' go back to text mode display, clearing any graphics on Panel3 while
' making it again the background for all 8 Labels. 
Sub RestoreTextModeDisplay
	Log("RestoreTextModeDisplay")
	lblLine1.BringToFront
	lblLine2.BringToFront
	lblLine3.BringToFront
	lblLine4.BringToFront
	lblLine5.BringToFront
	lblLine6.BringToFront
	lblLine7.BringToFront
	lblLine8.BringToFront
	' erase the graphics 
	Dim Rect1 As Rect
	' see https://www.b4x.com/android/forum/threads/drawing-lines-on-canvas.74810/#post-474888
	Dim scale As Double = 100dip / 100
	Rect1.Initialize(0, 0, Panel3.Width * scale, Panel3.Height * scale)
	cvsGraph.DrawRect(Rect1, Colors.White, True, 0)
	LCDGraphics.X = 0
	LCDGraphics.Y = 0
	
End Sub

' draw a graphics line encoded as per comments in the RX decoder routine
' The Buffer should point to Message + 5
Sub DrawGraphics(Buffer As String)
	
	Dim i, y As Int
	' Flag if all the data n the buffer is 55 which is what WFT seems to do if the waveform 
	' is all zeros.
	Dim All55 As Boolean = True
	' if we have not yet brought the panel to the front, do so
	'Log("DrawGraphics X " & LCDGraphics.X & " Y " & LCDGraphics.Y & " GM " & LCDGraphics.GMode) 
	
	If LCDGraphics.GMode = False Then 
		Panel3.BringToFront
		lblLine8.BringToFront
		LCDGraphics.GMode = True
		LCDGraphics.PendingData = False
		LCDGraphics.FirstLine = True
		LCDGraphics.Biggest = 0
		LCDGraphics.Smallest = 0
		LCDGraphics.X = 0
		LCDGraphics.Y = 0
	Else
		LCDGraphics.FirstLine = False
	End If
	Dim scale As Float = 100dip / 100
	' Release 3: cap the maximum scale to 2 so works on Jon's phone
	' My phone gives scale=2.0, xscale = 2.56, yscale= 3.93
	' Jon's gives scale = 3.0, xscale = 3.84, yscale = 5.93
	' just limiting scale to 2 stops it drawing off the bottom and righ ends of the control. 
	If scale > 2.0 Then
		scale = 2.0
	End If
	'Log("scale = " & scale)
	Dim xscale As Float = Panel3.Width / 256
	'Log("panel.w = " & Panel3.Width & " xscale = " & xscale & " xwidth = " & (xscale * Panel3.Width) & " d2c = " & DipToCurrent(Panel3.Width))
	Dim yscale As Float = Panel3.Height / 128
	'Log("panel.h = " & Panel3.Height & " yscale = " & yscale & " yheight = " & (yscale * Panel3.Height) & " d2c = " & DipToCurrent(Panel3.Height))

	If LCDGraphics.X = 0 Then
		'cvsGraph.DrawLine(0 * scale * xscale, 0 * scale * yscale, 0 * scale * xscale, 0.875 * 63 * scale * yscale, Colors.Red, 2 * scale) ' vertical
		cvsGraph.DrawLine(0 * scale * xscale, 0.875 * 32 * scale * yscale, 128 * scale * xscale, 0.875 * 32 * scale * yscale,  Colors.Red, 2 * scale) ' horizontal
		For i = 1 To 127
			' tick marks every 5 us (10 samples)
			If i Mod 10 = 0 Then
				cvsGraph.DrawLine(i * scale * xscale, 0.875 * 32 * scale * yscale - 5, i * scale * xscale, 0.875 * 32 * scale * yscale + 5, Colors.Red, 2 * scale)
			End If
		Next
	End If
	
	LCDGraphics.HalfScale = 0.875 * 32 * scale * yscale
	
	' check if the buffer is zeros (actually full scale due to WFT bug)
	For i = 0 To 63
		y = Asc(Buffer.CharAt(i)) - 64
		y = 63 - y
		If y <> 55 Then
			All55 = False
		End If
	Next

	For i = 0 To 63
		y = Asc(Buffer.CharAt(i)) - 64
		' invert y as I think the LCD grows from the bottom upwards
		' not forgetting that the lower 8 lines of virtual dots are not drawn on
		y = 63 - y
		' force y half scale
		If All55 Then y = 28
		
		If LCDGraphics.X = 0 Then
			LCDGraphics.X = 1 ' just to make it work or it never starts
			LCDGraphics.Y = y
		Else
			' Log(LCDGraphics.X & "," & LCDGraphics.Y & "," & y)
			cvsGraph.DrawLine(LCDGraphics.X * scale * xscale, LCDGraphics.Y * scale * yscale, (LCDGraphics.X + 1) * scale * xscale, y * scale * yscale, Colors.Black, 2 * scale)
			'Log((LCDGraphics.X * scale * xscale) & "," & (LCDGraphics.Y * scale * yscale) & "," & ((LCDGraphics.X + 1) * scale * xscale) & "," & (y * scale * yscale))
			LCDGraphics.X = LCDGraphics.X + 1
			LCDGraphics.Y = y
		End If
		' store the exportable data as a float array
		If LCDGraphics.FirstLine Then
			GraphicData(i) = y
		Else
			GraphicData(i + 64) = y
		End If
	Next

	' Do not forget to do this after drawing or it might not appear!!!
	Panel3.Invalidate

	
End Sub

' We colour the labels using the CSBuilder core object. 
' See CSBuilder tutorial at https://www.b4x.com/android/forum/threads/charsequence-csbuilder-tutorial.76226/#content
Sub LocalNetDisplay(Buffer As String, Payload As Int)
	' payload was in the format 4 hex digits xxyy
	' offset into the Buffer...
	' 0        1         2         3
	' 12345678901234567890123456789012
	' 0123456789ABCDEF0123456789ABCDEF
	' >aCC,XXYY1234567890123456789,XX
	' StrToDisplay(pStr+9, 21, 21);
	' On the HH, This func sets CursorX (0..127) and CursorY (0..7)
	' BUT the display fns in Terminal Mode never set XX to anything
	' other than 00, as we only ever replace complete lines starting at the start. 
	
	Dim LineNo, temp As Int
	LineNo = Payload
	'remove any high order (the xx value)
	temp = LineNo / 256
	LineNo = LineNo - (temp * 256)
	If LineNo > 7 Then LineNo = 0
	'adjust LineNo to 1..8
	LineNo = LineNo + 1
	Dim S As String
	S = Buffer.SubString(9)
	Dim CommaPos, n As Int
	CommaPos = S.Length - 1
	For n = 0 To S.Length - 1
		If S.SubString2(n, n+1) = "," Then
			CommaPos = n
		End If
	Next
	
	Dim opstring As String = S.SubString2(0, CommaPos)

	Dim highlight As Boolean
	Dim cs As CSBuilder
	
	' adjust the offsets of the highlighting to zero based
	If Highlighting.Start > -1 Then Highlighting.Start = Highlighting.Start - 9
	If Highlighting.Last > -1 Then Highlighting.Last = Highlighting.Last - 9
	' cap Highlight.Last because 04. LOGS & DOWNLOAD says end is at 22 when string is only 21 long!
	' but all the others are okay (now we subtract more then just 5 this probebly isn't needed)
	If Highlighting.Last > opstring.Length Then Highlighting.Last = opstring.Length - 1
	If Highlighting.Start > -1 And Highlighting.Last > -1 Then highlight = True Else highlight = False

	' Log(opstring & " , " & opstring.Length & " , " & Highlighting.Start & " , " & Highlighting.Last)
	If highlight Then
		cs.Initialize
		If Highlighting.Start > 0 Then
			cs.Initialize.Bold.Color(Colors.Black).Append(opstring.SubString2(0, Highlighting.Start))
			cs.Underline.Color(Colors.Red).Append(opstring.SubString2(Highlighting.Start, Highlighting.Last + 1)).PopAll ' popall ends current mode
			cs.Bold.Color(Colors.Black).Append(opstring.SubString(Highlighting.Last + 1)).PopAll
		Else	
			cs.Initialize.Underline.Bold.Color(Colors.Red).Append(opstring.SubString2(0, Highlighting.Last + 1)).PopAll
			If opstring.Length > Highlighting.Last Then
				cs.Bold.Color(Colors.Black).Append(opstring.SubString(Highlighting.Last + 1))
			End If
			cs.PopAll
		End If
		
	Else
		cs.Initialize
		cs.Initialize.Bold.Color(Colors.Black).Append(opstring).PopAll
		
	End If

	' If we write to Line 1, always cancel graphics mode
	Select LineNo 
		Case 1: If LCDGraphics.GMode = True Then 
					RestoreTextModeDisplay
					ScrubGraphics
				End If
				lblLine1.Text = cs 
		Case 2:	lblLine2.Text = cs 
		Case 3:	lblLine3.Text = cs 
		Case 4:	lblLine4.Text = cs 
		Case 5:	lblLine5.Text = cs 
		Case 6:	lblLine6.Text = cs 
		Case 7:	lblLine7.Text = cs 
		Case 8:	lblLine8.Text = cs 
				If LCDGraphics.GMode = True Then
					AddGraphicsToLog
				Else
					AddToLog
				End If
				If Common.MyMap.Get("AutoCap") Then
					Common.ScreenShot(Activity.Width, Activity.Height, "CWScrn")
				End If
				
	End Select
		
End Sub


Sub KeyMap As Int
	Private Map As Int = 0
	If ScanPressed > 0 Then Map = Map + 4 'KeyMap_SW3 0b00000100
	If LeftPressed > 0 Then Map = Map + 2 'KeyMap_SW2 0b00000010
	If RightPressed > 0 Then Map = Map + 8 'KeyMap_SW4 0b00001000
	If EnterPressed > 0 Then Map = Map + 32 'KeyMap_SW6 0b00100000
	Return Map
End Sub

Sub DecKeys
	If ScanPressed > 0 Then ScanPressed = ScanPressed - 1
	If LeftPressed > 0 Then LeftPressed = LeftPressed - 1
	If RightPressed > 0 Then RightPressed = RightPressed - 1
	If EnterPressed > 0 Then EnterPressed = EnterPressed - 1

End Sub

' Display framework for downloading from WFT
Sub Display_Downloading
	ClearDisplay
	lblLine1.Text = "     Downloading"
	lblLine4.Text = "     Please Wait"
End Sub

' Create file entry for downloading from WFT
Sub CreateDirEntry(Fname As String) As String
	If File.ExternalReadable = False Or File.ExternalWritable = False Then
		Return "SD Card Not R/W"
	Else
		Dim TextWriter1 As TextWriter
		Log(File.DirDefaultExternal & " " & Fname)
		TextWriter1.Initialize(File.OpenOutput(File.DirDefaultExternal, Fname, True))
		TextWriter1.Close
		Return "OK"	
	End If
End Sub

Sub AppendToFile(Fname As String, Buffer As String) As String
	Dim TextWriter1 As TextWriter
	TextWriter1.Initialize(File.OpenOutput(File.DirDefaultExternal, Fname, True))
	TextWriter1.Write(Buffer)
	TextWriter1.Close
	Return "OK"
End Sub

' Clears Highlighting record (not on-screen!)
Sub ClearHighlighting
	Highlighting.Start = -1
	Highlighting.Last = -1
End Sub

' add the current screen to the log file. This is called after Line 8 has been written unless Graphics mode. 
Sub AddToLog
	If myFileName <> "" Then
		AppendToFile(myFileName, myCRLF.ToString)
		AppendToFile(myFileName, DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & myCRLF.ToString)
		AppendToFile(myFileName, myStarString.ToString & myCRLF.ToString)
		AppendToFile(myFileName, lblLine1.Text & myCRLF.ToString)
		AppendToFile(myFileName, lblLine2.Text & myCRLF.ToString)
		AppendToFile(myFileName, lblLine3.Text & myCRLF.ToString)
		AppendToFile(myFileName, lblLine4.Text & myCRLF.ToString)
		AppendToFile(myFileName, lblLine5.Text & myCRLF.ToString)
		AppendToFile(myFileName, lblLine6.Text & myCRLF.ToString)
		AppendToFile(myFileName, lblLine7.Text & myCRLF.ToString)
		AppendToFile(myFileName, lblLine8.Text & myCRLF.ToString)
		AppendToFile(myFileName, myStarString.ToString & myCRLF.ToString)
		Log("AddToLog")
	End If
End Sub

' Add a graphics dump to the log file. This is called after Line 8 has been written if Graphics mode.
' Line 8 is sent as text and contains data as follows:
' CT= 3.4App [64u 19.1]
' Vs= 89Vpp [64u 547]
' Vp= 78Vpp [64u  47]
' Vn=  0vpp [64u   0]
' the 64u means that's the length of the samples, and the final number is out by a factor of 10
' and is supposed to be the largest or smallest single value i.e. 1.91, 54.7, 47, 0 above
Sub AddGraphicsToLog
	Dim S As String
	Dim Start, Finish As Int
	Start = lblLine8.Text.IndexOf("=") + 1
	If lblLine8.Text.SubString2(0, 2) = "CT" Then
		Finish = lblLine8.Text.IndexOf2("A", Start)
	Else
		Finish = lblLine8.Text.IndexOf2("V", Start)
	End If
	If (Finish > Start) Then
		S = lblLine8.Text.SubString2(Start, Finish)
	Else
		S = "0"
	End If
	
	Dim PPFloat As Float
			
	If IsNumber(S) Then
		PPFloat = S
	Else
		PPFloat = 0
	End If
	
	LCDGraphics.Biggest = 0
	LCDGraphics.Smallest = 63
	
	Dim i As Int
	For i = 0 To 127
		If GraphicData(i) > LCDGraphics.Biggest Then LCDGraphics.Biggest = GraphicData(i)
		If GraphicData(i) < LCDGraphics.Smallest Then LCDGraphics.Smallest = GraphicData(i)
		Log(GraphicData(i))
	Next
	
	Log("Biggest=" & LCDGraphics.Biggest)
	Log("Smallest=" & LCDGraphics.Smallest)
	
	Dim ConversionFactor As Float
	' Avoid divide by zero if no CTU connected and set ConversionFactor to -1
	' i.e. negative to flag the rest of the routine to zeroise
	If Abs(LCDGraphics.Biggest - LCDGraphics.Smallest) > 1 Then
		ConversionFactor = PPFloat / (LCDGraphics.Biggest - LCDGraphics.Smallest)
	Else
		ConversionFactor = 1 ' scale it at 1:1
	End If
	
	Log("ConversionFactor=" & ConversionFactor)
	
	' at this point we need to by moving the centre line up by 8 virtual bits
	' as the graphics screen is only the upper 7 lines out of 8. 
	' Then Invert it.

	For i = 0 To 127 
		GraphicData(i) = (GraphicData(i) - 27) * ConversionFactor
		GraphicData(i) = -GraphicData(i)
	Next
		
	
	If myFileName <> "" Then
		AppendToFile(myFileName, myCRLF.ToString)
		AppendToFile(myFileName, DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & myCRLF.ToString)
		AppendToFile(myFileName, myStarString.ToString & myCRLF.ToString)
		AppendToFile(myFileName, lblLine8.Text & myCRLF.ToString)
		' the data is added one entry per line, to make it easy to copy and paste the block
		' into our standard spreadsheet.
		For i = 0 To 127
			AppendToFile(myFileName, NumberFormat(GraphicData(i), 1, 3) & myCRLF.ToString) 
			Log(NumberFormat(GraphicData(i), 1, 3))
		Next
		AppendToFile(myFileName, myStarString.ToString & myCRLF.ToString)
		Log("AddGraphicsToLog")
	End If
	
	
End Sub


