﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.3
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	' see thread in https://www.b4x.com/android/forum/threads/anyone-remembers-ini-files-in-windows-before-registry.44102/
	Public MyMap As Map ' ini-like file
	Public PowerLogFile As String = ""
	Public StatsLogFile As String = ""
	Public RestartApp As Boolean = False ' V0.9.5 command to main module to restart the app
	' Keys for the Map File. MapUseLogin add 0.9.5
	Public Const IniFileName As String = "Bluetooth.ini"
	Public const mapServer As String = "Server"
	Public Const mapUsername As String = "Username"
	Public Const mapPassword As String = "Password"
	Public Const mapAutoCap As String = "AutoCap"
	Public Const mapSiteName As String = "SiteName"
	Public Const mapRecipient As String = "Recipient"
	Public const defServer As String = "https://clearwellappapi.azurewebsites.net/api/clearwell"
	Public Const defUsername As String = "clearwell@clearwell-os.com" 
	Public Const defPassword As String = "123456" ' V0.9.5
	Public Const defAutoCap As Boolean = False
	Public Const defSiteName As String = "Not Set"
	Public Const defRecipient As String = "sm@msluk.net"
	
	Public MyAliases As Map
	Public Const AliasFileName As String = "Aliases.ini"
	
	Public CurrentAlias As String = ""
	
	
	
End Sub

Sub InitMap
	MyMap.Initialize
	If File.Exists(File.DirDefaultExternal, IniFileName) = True Then
		MyMap = File.ReadMap(File.DirDefaultExternal, IniFileName)
		CheckMissingMapValues
	Else
		LoadnDefaultMap
	End If
End Sub

Sub ReadMapFromSD
	MyMap = File.ReadMap(File.DirDefaultExternal, IniFileName)
End Sub

Sub WriteMapToSD
	File.WriteMap(File.DirDefaultExternal, IniFileName, MyMap)
End Sub

Sub LoadnDefaultMap
	MyMap.Put(mapServer, defServer)
	MyMap.Put(mapUsername, defUsername)
	MyMap.Put(mapPassword, defPassword)
	MyMap.Put(mapAutoCap, defAutoCap) ' new V0.9.1
	MyMap.Put(mapSiteName, defSiteName) ' new V0.9.1
	MyMap.Put(mapRecipient, defRecipient) 'new V0.9.1
	File.WriteMap(File.DirDefaultExternal, IniFileName, MyMap)
	Log("LoadnDefaultMap")
End Sub

Sub SaveCurrentMap
	File.WriteMap(File.DirDefaultExternal, IniFileName, MyMap)
	Log("SaveCurrentMap")
End Sub

' This is needed if we add new fields because the values of the new fields are initially
' returned as null (since the older values and the file existed but they didn't).
' This will silently default them. 
Sub CheckMissingMapValues
	Dim FoundNull As Boolean = False
	If MyMap.Get(mapServer) = Null Then
		FoundNull = True
		MyMap.Put(mapServer, defServer)
	End If
	If MyMap.Get(mapUsername) = Null Then
		FoundNull = True
		MyMap.Put(mapUsername, defUsername)
	End If
	If MyMap.Get(mapPassword) = Null Then
		FoundNull = True
		MyMap.Put(mapPassword, defPassword)
	End If
	If MyMap.Get(mapAutoCap) = Null Then
		FoundNull = True
		MyMap.Put(mapAutoCap, defAutoCap) ' new V0.9.1
	End If
	If MyMap.Get(mapSiteName) = Null Then
		FoundNull = True
		MyMap.Put(mapSiteName, defSiteName) ' new V0.9.1
	End If
	If MyMap.get(mapRecipient) = Null Then
		FoundNull = True
		MyMap.Put(mapRecipient, defRecipient) ' new V0.9.1
	End If
	
	If FoundNull = True Then
		File.WriteMap(File.DirDefaultExternal, IniFileName, MyMap)
		Log("CheckMissingMapValues repaired ini file")
	End If
	

End Sub

' Load the Aliases, which are allowed to be empty
Sub InitAliases
	MyAliases.Initialize
	If File.Exists(File.DirDefaultExternal, AliasFileName) = True Then
		MyAliases = File.ReadMap(File.DirDefaultExternal, AliasFileName)
	End If
End Sub

Sub WriteAliasesToSD
	File.WriteMap(File.DirDefaultExternal, AliasFileName, MyAliases)
	InitAliases
End Sub


' From the manual Page 372: suggests assigning the sub to button_LongClick
' Needs Reflection Library
' Writes to root folder of SD card
' V0.9.1 added extra description to file name
Public Sub ScreenShot(Width As Int, Height As Int, Info As String) ' Take a screenshot.
	Private Obj1, Obj2 As Reflector
	Private bmp As Bitmap
	Private c As Canvas
	Private now As Long  ' example said now, i as long but i not used
	Private dt As String
	DateTime.DateFormat = "yyMMddHHmmss"
	now = DateTime.now
	dt = DateTime.Date(now) ' e.g.: "110812150355" is Aug.12, 2011, 3:03:55 p.m.
	Obj1.Target = Obj1.GetActivityBA
	Obj1.Target = Obj1.GetField("vg")
	bmp.InitializeMutable(Width, Height)
	c.Initialize2(bmp)
	Private args(1) As Object
	Private types(1) As String
	Obj2.Target = c
	Obj2.Target = Obj2.GetField("canvas")
	args(0) = Obj2.Target
	types(0) = "android.graphics.Canvas"
	Obj1.RunMethod4("draw", args, types)
	Private Out As OutputStream
	Out = File.OpenOutput(File.DirRootExternal, dt & Info & ".png", False)
	bmp.WriteToStream(Out, 100, "PNG")
	Out.Close
	Log("ScreenShot")
End Sub

' see https://www.b4x.com/android/forum/threads/prevent-phone-from-sleeping.41389/
' needs Reflection library. 
Sub KeepScreenOn(IsEnabled As Boolean)
	'Prevents the screen from sleeping when the current Activity is in the foreground
	Dim r As Reflector
	r.Target = r.GetActivity
	r.Target = r.RunMethod("getWindow")
	Dim FLAG_KEEP_SCREEN_ON As Int = 128
	If IsEnabled Then
		r.RunMethod2("addFlags", FLAG_KEEP_SCREEN_ON, "java.lang.int")
	Else
		r.RunMethod2("clearFlags", FLAG_KEEP_SCREEN_ON, "java.lang.int")
	End If
End Sub


