﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private lblPwrDns As Label
	Private lblPwrUps As Label
	Private lblStartDate As Label
	Private lblTimeDn As Label
	Private lblTimeUp As Label
	Private ListView1 As ListView
	
	' Non-struct vars as Stats members don't work
	Private PowerUps As Long
	Private PowerDns As Long
	Private StatsCorrupt As Long
	Private StatsTotal As Long
	Private StatsReversed As Long

	Private LastOn = 0, LastOff = 0 As Long
	Private StatsTimeOn, StatsTimeOff As Long
	Private const SecsInDay As Long = 86400
	Private const SecsInHour As Long = 3600
	Private const SecsInMinute As Long = 60
	
	Private lblCorrupt As Label
	Private lblReversals As Label
	Private lblWarnCorrupt As Label
	Private lblWarnReverse As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("4")
End Sub

Sub Activity_Resume
	Dim Labelx As Label
	'ListView1.SingleLineLayout.ItemHeight = 45
	' Labelx acts as a sort of pointer into the template label for each item in the list.
	Labelx = ListView1.SingleLineLayout.Label
	Labelx.TextSize = 18
	Labelx.TextColor = Colors.Black
	Analyse_PowerLog(Common.PowerLogFile)
	ListView1.FastScrollEnabled = True
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Analyse_PowerLog(FileName As String)
	Dim List1 As List
	Dim i, DTicks, LastTicks As Long
	
	StatsCorrupt = 0
	StatsTotal = 0
	StatsReversed = 0
	
	DateTime.DateFormat = "yyyy-MM-dd"
	DateTime.TimeFormat = "HH:mm:ss"
	LastTicks = DateTime.DateTimeParse("2013-01-01",  "01:00:00")

	If FileName = "" Then 
		ToastMessageShow("No file Specified", True)
	Else
		ListView1.Clear
		List1 = File.ReadList(File.DirDefaultExternal, FileName)
		' LastTicks is used by the function to detect time going backwards
		For i = 0 To List1.Size - 1
			LastTicks = CompilePLData(List1.Get(i), i, List1.Size - 1, LastTicks)
		Next
		'lblStartDate.Text = Stats.Start
		' Add the datestamp of the file to the on time total
		DateTime.DateFormat = "yyyy-MM-dd"
		DateTime.TimeFormat = "HH-mm-ss"
		Dim StartofDatePos As Int
		' Code Base 3 (V0.9.3) fix bug introduced by adding the alias by finding the start of date
		StartofDatePos = FileName.IndexOf("-20") + 1
		DTicks = DateTime.DateTimeParse(FileName.SubString2(StartofDatePos, StartofDatePos+10), FileName.SubString(StartofDatePos+11))
		StatsTimeOn = StatsTimeOn + DTicks - LastOn
		lblPwrUps.Text = "Pwr Ups:" & PowerUps
		lblPwrDns.Text = "Pwr Dns:" & PowerDns
		lblTimeUp.Text = ElapsedTimeString(StatsTimeOn)
		lblTimeDn.Text = ElapsedTimeString(StatsTimeOff)
		If StatsReversed > 0 Then
			lblReversals.Text = "Reverse:" & StatsReversed
			lblWarnReverse.Text = "Date Calcs Warning"
			lblReversals.Visible = True
			lblWarnReverse.Visible =True
		Else
			lblReversals.Visible = False
			lblWarnReverse.Visible = False
		End If
		If 	StatsCorrupt > 0 Then
			lblCorrupt.Text = "Corrupt:" & StatsCorrupt	
			lblWarnCorrupt.Text = "Corrupt Recs Warning"
			lblCorrupt.Visible = True
			lblWarnCorrupt.Visible = True
		Else
			lblCorrupt.Visible = False
			lblWarnCorrupt.Visible = False
		End If
	
		ListView1.FastScrollEnabled = True
		
	End If

End Sub

Sub ElapsedTimeString(InTicks As Long) As String
	Dim S As String
	Dim Ticks, Days, Hours, Minutes As Long
	Ticks = InTicks / 1000
	Days = Ticks / SecsInDay
	If Days > 0 Then Ticks = Ticks - (Days * SecsInDay)
	Hours = Ticks / SecsInHour
	If Hours > 0 Then Ticks = Ticks - (Hours * SecsInHour)
	Minutes = Ticks / SecsInMinute
	S = Days & " days, " & Hours & " hrs " & Minutes & " min"
	
	Return S
End Sub

Sub CompilePLData(LineIn As String, Index As Long, MaxIndex As Long, myLastTicks As Long) As Long
	Dim DT As String
	Dim Code As String
	DateTime.DateFormat = "yyyy-mm-dd HH:mm:ss"
	
	Dim Interpreted As String
	Dim DateTicks, ThisTicks, DTTicks As Long
	
	
	Dim cs As CSBuilder
	Dim Problema As Int = 0
	Dim Marker As Int
	
	ThisTicks = myLastTicks
	
	StatsTotal = Index
	' V0.9.5 protect against power log parse crashing due to invalid length line, don't
	' copy it to the output but just say Corrupted Data.
	' Otherwise the program will crash when it tries to parse the data and time info. 
	If LineIn.IndexOf(",") = -1 Or LineIn.Length <> 21 Then
		StatsCorrupt = StatsCorrupt + 1
		Problema = 1
		' copy the line verbatim to the output
		cs.Initialize
		cs.Initialize.Underline.Bold.Color(Colors.Red).Append("Corrupted Data").PopAll
		ListView1.AddSingleLine(cs)
	Else
		' Parse out the two fields	
		Marker = LineIn.IndexOf(",")
		DT = LineIn.SubString2(0, Marker)
		Code = LineIn.SubString(Marker + 1)
		DateTime.DateFormat = "yyyy-MM-dd"
		DateTime.TimeFormat = "HH:mm:ss"
		DateTicks = DateTime.DateTimeParse(DT.SubString2(0, 10), DT.SubString(11))
		'TimeTicks = DateTime.TimeParse(DT.SubString(11))
		
		Select Code
			Case "0"
				'Stats.Start = DateTime.DateTimeParse(DT.SubString2(0, 10), DT.SubString(11)) 
				Interpreted = "Start"
				lblStartDate.Text = "Start: " & DT
				LastOn = DateTicks

			Case "1"
				' on
				Interpreted = "Power Up"
				PowerUps = PowerUps + 1 
				LastOn = DateTicks
				If LastOff <> 0 Then
					StatsTimeOff = StatsTimeOff + DateTicks - LastOff
				End If
			Case "2"				
				' off
				Interpreted = "Power Down"
				PowerDns = PowerDns + 1 
				LastOff = DateTicks
				If LastOn <> 0 Then
					StatsTimeOn = StatsTimeOn + DateTicks - LastOn
				End If
				
			Case "3"
				Interpreted = "Comms Up"
			Case "4"
				Interpreted = "Comms Down"
			Case "5"
				Interpreted = "CTU Power Up"
			Case "6"
				Interpreted = "Power On Overload"
			Case "7"
				Interpreted = "CTU Coil o/c"
			Case "8"
				Interpreted = "CTU Coil s/c"
			Case "9"
				Interpreted = "Low Voltage"
			Case "A"
				Interpreted = "Settings1 Missing"
			Case "B"
				Interpreted = "Settings2 Missing"
			Case "C"
				Interpreted = "Settings2 -> 1"
			Case "D"
				Interpreted = "Settings1 -> 2"
			Case "E"
				Interpreted = "Settings Defaulted"
			Case "F"
				Interpreted = "MO Msg Fail 1"
			Case "G" ' 10
				Interpreted = "MO Msg Fail 2"
			Case "H" ' 11
				Interpreted = "MO Msg Fail 3"
			Case "I"
				Interpreted = "MO Msg Fail 4"
			Case "J"
				Interpreted = "MO Msg Fail 5"
			Case "K"
				Interpreted = "MO Msg Sent"
			Case "L"
				Interpreted = "Sat SWR Req"
			Case "M"
				Interpreted = "PU Software RST"
				PowerUps = PowerUps + 1
				LastOn = DateTicks
				If LastOff <> 0 Then
					StatsTimeOff = StatsTimeOff + DateTicks - LastOff
				End If
			Case "N"
				Interpreted = "PU Low Power RST"
				PowerUps = PowerUps + 1
				LastOn = DateTicks
				If LastOff <> 0 Then
					StatsTimeOff = StatsTimeOff + DateTicks - LastOff
				End If
			Case "O"
				Interpreted = "PU Window WDog RST"
				PowerUps = PowerUps + 1
				LastOn = DateTicks
				If LastOff <> 0 Then
					StatsTimeOff = StatsTimeOff + DateTicks - LastOff
				End If
			Case "P"
				Interpreted = "PU Ind WDog RST"
				PowerUps = PowerUps + 1
				LastOn = DateTicks
				If LastOff <> 0 Then
					StatsTimeOff = StatsTimeOff + DateTicks - LastOff
				End If
			Case "Q" 
				Interpreted = "MO Msg Fail SPDIX"
			Case Else
				Interpreted = "Unknown Code"
				Problema = 2
		End Select
		
		DTTicks = DateTicks
		' use a safety margin of about 10 seconds
		If ThisTicks > (DTTicks + 100000) Then
			Problema = 3
			Interpreted = "Reversed Time!!!"
			StatsReversed = StatsReversed + 1
		End If
		
		ThisTicks = DateTicks
		
		cs.Initialize
		' Case 1 is handled above
		Select Problema
			Case 0: ' Okay
				cs.Initialize.Color(Colors.Black).Append(LineIn.SubString2(0, Marker) & "," & Interpreted).PopAll
			Case 2: ' illegal code
				cs.Initialize.Underline.Bold.Color(Colors.Cyan).Append(LineIn).PopAll
			Case 3: ' time went backwards
				cs.Initialize.Bold.Color(Colors.Yellow).Append(LineIn.SubString2(0, Marker) & "," & Interpreted).PopAll
		End Select
		
		ListView1.AddSingleLine(cs)
	End If
	
	Log("Returning: " & ThisTicks)
	Return ThisTicks

End Sub
