﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

' See example ScrollViewExample which this was derived from
Sub Process_Globals
	Public StringUtils1 As StringUtils

	Public NumberOfColumns As Int				: NumberOfColumns = 18
	Public NumberOfRows As Int
	Public RowHeight As Int						: RowHeight = 40dip ' Sm was 30
	Public RowLineWidth As Int					: RowLineWidth = 1dip
	Public RowHeight_1 As Int					: RowHeight_1 = RowHeight - RowLineWidth
	Public ColLineWidth As Int					: ColLineWidth = 1dip
	Public ColumnWidth(NumberOfColumns) As Int
	Public SMColWidth As Int 					: SMColWidth = 50dip
	Public ColumnWidth_1(NumberOfColumns) As Int
	Public TotalColumnWidth(NumberOfColumns + 1) As Int
	
	Public HeaderColor As Int					: HeaderColor = Colors.White
	Public HeaderFontColor As Int				: HeaderFontColor = Colors.Black
	Public HeaderLineColor As Int				: HeaderLineColor = Colors.Black
	Public LineColor As Int						: LineColor = Colors.Black
	Public CellColor As Int						: CellColor = Colors.RGB(255,255,220)
	Public FontColor As Int						: FontColor = Colors.Black
	Public FontSize As Float					: FontSize = 14
	Public Alignment As Int						: Alignment = Gravity.CENTER
	Public SelectedRow As Int					: SelectedRow = -1
	Public SelectedRowColor As Int				: SelectedRowColor=Colors.RGB(255,196,255)
	Public SelectedCellColor As Int				: SelectedCellColor=Colors.RGB(255,150,255)
	Type RowCol (Row As Int, Col As Int)
	Public MoveLeft0, MoveX0, MoveX1, DeltaScroll, DeltaX As Float
	Public Time0 As Long
	Public Timer1 As Timer

	' SM add vars to allow loading of chunks of the file
	Public FileLines As Long = 0	
	Public FileBlock As Int = 0
	Public StartDataLine As Long
	Public MaxLines As Long
	Public DisplayEnd As Long

End Sub

Sub Globals
	Public scvPersons As ScrollView
	Public pnlHeader As Panel
	Public skbScroll As SeekBar
	Public pnlScroll As Panel
	' SM
	Public btnBack As Button
	Public btnFwd As Button
	Private Label1 As Label ' hidden label in unused layout f_awesome
End Sub

' As per the example, this creates the Activity's screen all in code...
Sub Activity_Create(FirstTime As Boolean)
	Public i As Int
	Dim ListTemp As List
	
	' Scroll panel at the bottom
	pnlScroll.Initialize("pnlScroll")	' initialize the scroll panel
	Activity.AddView(pnlScroll, 0, Activity.Height - 40dip, 100%x, 40dip)
	pnlScroll.Color = Colors.LightGray
	
	' scroll bar on the scroll panel
	skbScroll.Initialize("skbScroll")	' initilaize the Seekbar
	'Activity.AddView(skbScroll, 0, Activity.Height - 40dip, 100%x, 40dip)
	' SM leave room to the left for two small buttons
	Activity.AddView(skbScroll, 40%x, Activity.Height - 40dip, 100%x, 40dip)
	skbScroll.Visible = True
	'	skbScroll.Visible = False
	
	Label1.Initialize("Label1")
	btnBack.Initialize("btnBack")
	Activity.AddView(btnBack, 0, Activity.Height - 40dip, 15%x, 40dip)
	btnBack.Visible = True
	'btnBack.Typeface = Label1.Typeface ' need to create with designer to get font in APK
	btnBack.Text = "<<"
	btnFwd.Initialize("btnFwd")
	Activity.AddView(btnFwd, btnBack.Width, Activity.Height - 40dip, 15%x, 40dip)
	btnFwd.Visible = True
	'btnFwd.Typeface = Label1.Typeface
	btnFwd.Text = ">>"
	
	
	
	
	scvPersons.Initialize(0)	' initialize the ScrollView
	scvPersons.Panel.Color = LineColor
	Activity.AddView(scvPersons,0,RowHeight,100%x,pnlScroll.Top-RowHeight)
	
	' initialze the internal column width and left coordinates
	TotalColumnWidth(0) = ColLineWidth
	For i = 0 To NumberOfColumns - 1
		' SM added: make the first column wider than all the others the same
		If i = 0 Then
			ColumnWidth(i) = 120dip
		Else
			ColumnWidth(i) = SMColWidth
		End If
		' back to original code
		ColumnWidth_1(i) = ColumnWidth(i) - ColLineWidth
		TotalColumnWidth(i + 1) = TotalColumnWidth(i) + ColumnWidth(i)
	Next
	
	' initializes the ScrollView width SM this looks perfectly sensible in dips
	scvPersons.Width = TotalColumnWidth(NumberOfColumns)
	
	' Dim scale As Float = 100dip / 100	
	
	' initializes the Seekbar max valueSM - (from zero). This is reported to its
	' event handler which scrolls left/right by adjusting the scrolled views'
	' Left properties. The problem with this is that the width is calculated as Dips
	' but the Activity.Width isn't and I have been unable to frig it so we don't
	' scroll off the right hand end of the scroll area...
	skbScroll.Max = scvPersons.Width - Activity.Width
	Log("skbScroll.Max=" & skbScroll.Max & " scvPersons.Width=" & scvPersons.Width & " Activity.Width=" & Activity.Width)
	
	SelectedRow = -1		' sets the selected row index to -1
	
	' SM determine the number of lines in the file
	ListTemp.Initialize
	ListTemp = File.ReadList(File.DirDefaultExternal, Common.StatsLogFile)
	' pretend that the headings are not there because the CSV fn does and enumerates the data lines from 0
	FileLines = ListTemp.Size - 1
	ListTemp.Clear
	Log("FileLines=" & FileLines)
	StartDataLine = 0
	MaxLines = 100
	
	' loads the csv file
	
	DisplayEnd = LoadTableFromCSV(File.DirDefaultExternal, Common.StatsLogFile, StartDataLine, MaxLines)
	'	SaveTableToCSV(File.DirRootExternal, "persons.csv")
	Log("StartDataLine=" & StartDataLine & " DisplayEnd=" & DisplayEnd)
	
	Update_Title
	
	Timer1.Initialize("Timer1",100)
	
	ProgressDialogHide

End Sub

Sub Activity_Resume

	
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub btnBack_Click
	Log("btnBack")
	If StartDataLine > MaxLines Then
		StartDataLine = StartDataLine - MaxLines
		Log("StartDataLine=" & StartDataLine & " DisplayEnd=" & DisplayEnd) 
		DisplayEnd = LoadTableFromCSV(File.DirDefaultExternal, Common.StatsLogFile, StartDataLine, MaxLines)
		Log("StartDataLine=" & StartDataLine & " DisplayEnd=" & DisplayEnd)
	Else
		ToastMessageShow("Reached start of file", True)
	End If
	Update_Title
End Sub

Sub btnFwd_Click
	Log("btnFwd")
	If DisplayEnd < (FileLines - 2) Then
		StartDataLine = StartDataLine + MaxLines
		Log("StartDataLine=" & StartDataLine & " DisplayEnd=" & DisplayEnd)
		' do not try to display the whole Maxlines files, just the few that are left
		DisplayEnd = LoadTableFromCSV(File.DirDefaultExternal, Common.StatsLogFile, StartDataLine, MaxLines)
		Log("StartDataLine=" & StartDataLine & " DisplayEnd=" & DisplayEnd)
	Else
		ToastMessageShow("Reached end of file", True)
	End If
	Update_Title
End Sub

Sub Update_Title
	Dim PageNum, NumPages As Int
	
	NumPages = (FileLines/MaxLines) + 1
	Dim OnPerc As Float = StartDataLine / FileLines
	Dim PagePerc As Float = NumPages * OnPerc + 1
	PageNum = PagePerc
	Activity.Title = "Log:" & Common.StatsLogFile & ", " & PageNum & "/" & NumPages
End Sub

' SM I have modified this to specify Headers always exist and to accept read the file in chunks.
' See the original in the Scroll View Example for the original
Sub LoadTableFromCSV(Dir As String,Filename As String, Start As Long, LinesLimit As Long) As Long
	
	ProgressDialogShow("Loading")
	
	ClearAll	'Clears the previous table and loads the CSV file to the table
	Private List1 As List
	Private i As Long
	
	Public h() As String

	' Reads the csv file
	Private headers As List
	List1 = StringUtils1.LoadCSV2(Dir, Filename, ",", headers)
	' Sets the header names of the columns
	Private h(headers.Size) As String
	For i = 0 To headers.Size - 1
		h(i) = headers.Get(i)
	Next

	NumberOfColumns = h.Length	' Gets the number of columns
	SetHeader(h)				' Sets the headers
	
	NumberOfRows = 0
	
	Dim Target As Long
	
	If List1.Size < (Start + LinesLimit) Then
		' not enough; prune target
		Target = List1.Size - 1
	Else
		' more than enough; last line = first line plus lines limit
		Target = LinesLimit + Start - 1
	End If

	For i = Start To Target

		' Fills the table
		Private row() As String
		row = List1.Get(i)
		AddRow(row)
	Next
	
	ProgressDialogHide
	
	Return Target
	
End Sub

Sub SaveTableToCSV(Dir As String, Filename As String)
	'Saves the current table into a csv file
	Private headers(NumberOfColumns) As String
	For i = 0 To headers.Length - 1
		Public l As Label
		l = pnlHeader.GetView(i)
		headers(i) = l.Text
	Next
	Private list1 As List
	list1.Initialize
	For i = 0 To NumberOfRows - 1
		Private row(NumberOfColumns) As String
		For c = 0 To NumberOfColumns - 1
			row(c) = GetCell(i, c)
		Next
		list1.Add(row)
	Next
	StringUtils1.SaveCSV2(Dir, Filename, ",", list1, headers)
End Sub

Sub Cell_Click
	Private rc As RowCol
	Private l As Label
	
	l = Sender
	rc = l.Tag
	SelectRow(rc)
	Activity.Title = "Cell: ("&rc.Row&", "& rc.Col&") "&GetCell(rc.Row, rc.Col)
End Sub

Sub Header_Click
	Private l As Label
	Private col As Int
	
	l = Sender
	col = l.Tag
	Activity.Title = "Header clicked: " & col
End Sub

Sub SelectRow(rc As RowCol)
	Private col As Int

	'Removes the color of previously selected row
	If SelectedRow > -1 Then
		For col = 0 To NumberOfColumns - 1
			GetView(SelectedRow, col).Color = CellColor
		Next
	End If

	SelectedRow = rc.Row
	
	'Sets the color of the selected row and selected cell
	For col = 0 To NumberOfColumns - 1
		If col = rc.col Then
			GetView(rc.Row, col).Color = SelectedCellColor
		Else
			GetView(rc.Row, col).Color = SelectedRowColor
		End If
	Next
End Sub

Sub GetView(Row As Int, Col As Int) As Label
	'Returns the label in the specific cell
	Private l As Label
	
	l = scvPersons.Panel.GetView(Row * NumberOfColumns + Col)
	Return l
End Sub

Sub AddRow(Values() As String)
	'Adds a row to the table
	If Values.Length <> NumberOfColumns Then
		Log("Wrong number of values.")
		Return
	End If

	For i = 0 To NumberOfColumns - 1
		Private l As Label
		l.Initialize("cell")
		l.Text = Values(i)
		l.Gravity = Alignment
		l.TextSize = FontSize
		l.TextColor = FontColor
		l.Color=CellColor
		Private rc As RowCol
		rc.Initialize
		rc.Col = i
		rc.Row = NumberOfRows
		l.Tag = rc
		scvPersons.Panel.AddView(l, TotalColumnWidth(i), RowHeight * NumberOfRows, _
		ColumnWidth_1(i), RowHeight_1)
	Next
	NumberOfRows = NumberOfRows + 1
	scvPersons.Panel.Height = NumberOfRows * RowHeight
End Sub

Sub SetHeader(Values() As String)
	'Set the headers values
	If pnlHeader.IsInitialized Then Return 'should only be called once
	pnlHeader.Initialize("")
	pnlHeader.Color = HeaderLineColor
	For i = 0 To NumberOfColumns - 1
		Private l As Label
		l.Initialize("Header")
		l.Text = Values(i)
		l.Gravity = Gravity.CENTER
		l.TextSize = FontSize
		l.Color = HeaderColor
		l.TextColor = HeaderFontColor
		l.Tag = i
		pnlHeader.AddView(l,TotalColumnWidth(i),0,ColumnWidth_1(i),RowHeight_1)
	Next
	Activity.AddView(pnlHeader,scvPersons.Left,0,scvPersons.Width,RowHeight)
End Sub

Sub SetCell(Row As Int, Col As Int, Value As String)
	'Sets the value of the given cell
	GetView(Row, Col).Text = Value
End Sub

Sub GetCell(Row As Int, Col As Int) As String
	'Gets the value of the given cell
	Return GetView(Row, Col).Text
End Sub

Sub ClearAll
	'Clears the table
	For i = scvPersons.Panel.NumberOfViews -1 To 0 Step -1
		scvPersons.Panel.RemoveViewAt(i)
	Next
	scvPersons.Panel.Height = 0
	SelectedRow = -1
End Sub

Sub skbScroll_ValueChanged (Value As Int, UserChanged As Boolean)
	'Moves the ScrollView horizontally
	pnlHeader.Left = - Value
	scvPersons.Left = - Value
	Log("Value=" & Value & " Left=" & pnlHeader.Left)
End Sub

Sub pnlScroll_Touch (Action As Int, X As Float, Y As Float)
	Public Left As Float
	
	Select Action
		Case Activity.ACTION_DOWN
			MoveLeft0 = -scvPersons.Left
			MoveX0 = X
			MoveX1 = X
			Time0 = DateTime.Now
		Case Activity.ACTION_MOVE
			Left = MoveLeft0 + (MoveX0 - X)
			Left = Max(Left, 0)
			Left = Min(Left, TotalColumnWidth(NumberOfColumns) - Activity.Width)
			scvPersons.Left = -Left
			pnlHeader.Left = -Left
			DeltaX = X - MoveX1
			MoveX1 = X
		Case Activity.ACTION_UP
			Time0 = (DateTime.Now - Time0)
			DeltaScroll = (X - MoveX0) / Time0 * 80
			If Abs(DeltaScroll) > 5dip And Abs(DeltaX) > 10dip Then
				Timer1.Enabled = True
			End If
	End Select
End Sub

Sub Timer1_Tick
	Private Left As Float
	
	Left = scvPersons.Left + DeltaScroll
	If Left > 0 Then
		Left = 0
		Timer1.Enabled = False
	End If
	If Left < -(TotalColumnWidth(NumberOfColumns) - Activity.Width) Then
		Left = -(TotalColumnWidth(NumberOfColumns) - Activity.Width)
		Timer1.Enabled = False
	End If
	
	scvPersons.Left = Left
	pnlHeader.Left = Left
	
	DeltaScroll = DeltaScroll / 1.2
	If Abs(DeltaScroll) < 5dip Then
		Timer1.Enabled = False
	End If
End Sub

